<?php
/*##################################################
 *                              guestbook.php
 *                            -------------------
 *   begin                : July 11, 2005
 *   copyright          : (C) 2005 Viarre Rgis
 *   email                : crowkait@phpboost.com
 *
 *
###################################################
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
###################################################*/

include_once('../includes/begin.php'); 
include_once('../guestbook/lang/' . $CONFIG['lang'] . '/guestbook_' . $CONFIG['lang'] . '.php'); //Chargement de la langue du module.
define('TITLE', $LANG['title_guestbook']);
include_once('../includes/header.php'); 

if( !$groups->check_auth($SECURE_MODULE['guestbook'], ACCESS_MODULE) )
{
	$errorh->error_handler('e_auth', E_USER_REDIRECT); 
	exit;
}

$id_get = ( !empty($_GET['id'])) ? numeric($_GET['id']) : '' ;
//Chargement du cache
$cache->load_file('guestbook');
		
if( !empty($_POST['guestbook']) && empty($id_get) ) //Enregistrement
{
	$guestbook_contents = !empty($_POST['guestbook_contents']) ? $_POST['guestbook_contents'] : '';
	$guestbook_pseudo = !empty($_POST['guestbook_pseudo']) ? securit($_POST['guestbook_pseudo']) : $LANG['guest'];

	//Membre en lecture seule?
	if( $session->data['user_readonly'] > time() ) 
	{
		$errorh->error_handler('e_readonly', E_USER_REDIRECT); 
		exit;
	}
	
	if( !empty($guestbook_contents) && !empty($guestbook_pseudo) )
	{	
		//Accs pour poster.			
		if( $session->check_auth($session->data, $CONFIG_GUESTBOOK['guestbook_auth']) )
		{
			//Mod anti-flood
			$check_time = ($session->data['user_id'] !== -1 && $CONFIG['anti_flood'] == 1) ? $sql->query("SELECT MAX(timestamp) as timestamp FROM ".PREFIX."guestbook WHERE user_id = '" . $session->data['user_id'] . "'", __LINE__, __FILE__) : '';
			if( !empty($check_time) )
			{			
				if( $check_time >= (time() - $CONFIG['delay_flood']) ) //On calcul la fin du delai.	
				{
					header('location:' . HOST . SCRIPT . transid('?error=flood', '', '&') . '#errorh');
					exit;
				}	
			}
		
			$guestbook_contents = parse($guestbook_contents, $CONFIG_GUESTBOOK['guestbook_forbidden_tags']); 			
			if( !check_nbr_links($guestbook_contents, $CONFIG_GUESTBOOK['guestbook_max_link']) ) //Nombre de liens max dans le message.
			{	
				header('location:' . HOST . SCRIPT . transid('?error=l_flood', '', '&') . '#errorh');
				exit;
			}			
			
			$sql->query_inject("INSERT INTO ".PREFIX."guestbook (contents,login,user_id,timestamp) VALUES('" . $guestbook_contents . "', '" . $guestbook_pseudo . "', '" . $session->data['user_id'] . "', '" . time() . "')", __LINE__, __FILE__);
			$last_msg_id = $sql->sql_insert_id("SELECT MAX(id) FROM ".PREFIX."guestbook"); //Dernier message insr.
			
			header('location:' . HOST . SCRIPT . SID2 . '#m' . $last_msg_id);
			exit;
		}
		else //utilisateur non autoris!
		{
			header('location:' . HOST . SCRIPT . transid('?error=auth', '', '&') . '#errorh');
			exit;
		}
	}
	else
	{
		header('location:' . HOST . SCRIPT . transid('?error=incomplete', '', '&') . '#errorh');
		exit;
	}
}
elseif( !empty($_POST['previs']) ) //Prvisualisation.
{
	$template->set_filenames(array(
		'guestbook' => '../templates/' . $CONFIG['theme'] . '/guestbook/guestbook.tpl'
	));

	$user_id = $sql->query("SELECT user_id FROM ".PREFIX."guestbook WHERE id = '" . $id_get . "'", __LINE__, __FILE__);
	$user_id = (int)$user_id;
	
	$guestbook_contents = !empty($_POST['guestbook_contents']) ? trim($_POST['guestbook_contents']) : '';
	$guestbook_pseudo = !empty($_POST['guestbook_pseudo']) ? securit($_POST['guestbook_pseudo']) : '';
	
	//Pseudo du membre connect.
	if( $user_id !== -1)
		$template->assign_block_vars('hidden_guestbook', array(
			'PSEUDO' => $guestbook_pseudo
		));
	else
		$template->assign_block_vars('visible_guestbook', array(
			'PSEUDO' => stripslashes($guestbook_pseudo)
		));

	$forbidden_tags = implode(', ', $CONFIG_GUESTBOOK['guestbook_forbidden_tags']);
	$template->assign_block_vars('guestbook', array(
		'CONTENTS' => second_parse(stripslashes(parse($guestbook_contents, $CONFIG_GUESTBOOK['guestbook_forbidden_tags']))),
		'PSEUDO' => stripslashes($guestbook_pseudo),
		'DATE' => date($LANG['date_format'], time()),
		'THEME' => $CONFIG['theme'],
		'FORBIDDEN_TAGS' => !empty($forbidden_tags) ? $forbidden_tags : '',
		'DISPLAY_FORBIDDEN_TAGS' => !empty($forbidden_tags) ? '[' . str_replace(', ', '], [', $forbidden_tags) . ']' : '',
		'L_FORBIDDEN_TAGS' => !empty($forbidden_tags) ? $LANG['forbidden_tags'] : '',
	));

	//On met  jour en cas d'dition aprs prvisualisation du message
	$update = (!empty($_GET['update']) && !empty($id_get)) ? '?update=1&amp;id=' . $id_get : '';
	
	$template->assign_vars(array(
		'CONTENTS' => stripslashes($guestbook_contents),
		'PSEUDO' => stripslashes($guestbook_pseudo),
		'DATE' => date($LANG['date_format'], time()),
		'UPDATE' => transid($update),
		'ERROR' => '',
		'L_ALERT_TEXT' => $LANG['require_text'],
		'L_UPDATE_MSG' => $LANG['update_msg'],
		'L_REQUIRE' => $LANG['require'],
		'L_MESSAGE' => $LANG['message'],
		'L_PSEUDO' => $LANG['pseudo'],
		'L_SUBMIT' => $LANG['submit'],
		'L_PREVIEW' => $LANG['preview'], 
		'L_RESET' => $LANG['reset'],
		'L_ON' => $LANG['on']
	));	
	
	$_field = 'guestbook_contents';
	include_once('../includes/bbcode.php');
	$template->assign_var_from_handle('BBCODE', 'bbcode');
	
	$template->pparse('guestbook'); 
}
elseif( !empty($id_get) ) //Edition + suppression!
{
	$del = !empty($_GET['del']) ? $_GET['del'] : '';
	$edit = !empty($_GET['edit']) ? $_GET['edit'] : '';
	$update = !empty($_GET['update']) ? $_GET['update'] : '';
	
	$row = $sql->query_array('guestbook', '*', 'WHERE id="' . $id_get . '"', __LINE__, __FILE__);
	$row['user_id'] = (int)$row['user_id'];
	
	if( $session->check_auth($session->data, 1) || ($row['user_id'] === $session->data['user_id'] && $session->data['user_id'] !== -1) )
	{
		if( $del )
		{
			$sql->query_inject("DELETE FROM ".PREFIX."guestbook WHERE id = '" . $id_get . "'", __LINE__, __FILE__);
			$previous_id = $sql->query("SELECT MAX(id) FROM ".PREFIX."guestbook", __LINE__, __FILE__);
			
			header('location:' . HOST . SCRIPT . SID2 . '#m' . $previous_id);
			exit;
		}
		elseif( $edit )
		{
			$template->set_filenames(array(
				'guestbook' => '../templates/' . $CONFIG['theme'] . '/guestbook/guestbook.tpl'
			));

			if( $row['user_id'] !== -1 )
				$template->assign_block_vars('hidden_guestbook', array(
					'PSEUDO' => $row['login']
				));
			else
				$template->assign_block_vars('visible_guestbook', array(
					'PSEUDO' => $row['login']
				));		
			
			$forbidden_tags = implode(', ', $CONFIG_GUESTBOOK['guestbook_forbidden_tags']);
			$template->assign_vars(array(
				'UPDATE' => transid('?update=1&amp;id=' . $id_get),
				'CONTENTS' => unparse($row['contents']),
				'DATE' => date($LANG['date_format'], $row['timestamp']),
				'THEME' => $CONFIG['theme'],
				'FORBIDDEN_TAGS' => !empty($forbidden_tags) ? $forbidden_tags : '',
				'DISPLAY_FORBIDDEN_TAGS' => !empty($forbidden_tags) ? '[' . str_replace(', ', '], [', $forbidden_tags) . ']' : '',
				'L_FORBIDDEN_TAGS' => !empty($forbidden_tags) ? $LANG['forbidden_tags'] : '',
				'L_ALERT_TEXT' => $LANG['require_text'],
				'L_UPDATE_MSG' => $LANG['update_msg'],
				'L_REQUIRE' => $LANG['require'],
				'L_MESSAGE' => $LANG['message'],
				'L_PSEUDO' => $LANG['pseudo'],
				'L_SUBMIT' => $LANG['update'],
				'L_PREVIEW' => $LANG['preview'], 
				'L_RESET' => $LANG['reset']
			));
			
			$_field = 'guestbook_contents';
			include_once('../includes/bbcode.php');
			$template->assign_var_from_handle('BBCODE', 'bbcode');
			
			$template->pparse('guestbook'); 
		}
		elseif( $update )
		{
			$guestbook_contents = !empty($_POST['guestbook_contents']) ? trim($_POST['guestbook_contents']) : '';			
			$guestbook_pseudo = !empty($_POST['guestbook_pseudo']) ? securit($_POST['guestbook_pseudo']) : '';			
			if( !empty($guestbook_contents) && !empty($guestbook_pseudo) )
			{
				$guestbook_contents = parse($guestbook_contents, $CONFIG_GUESTBOOK['guestbook_forbidden_tags']); 			
				if( !check_nbr_links($guestbook_contents, $CONFIG_GUESTBOOK['guestbook_max_link']) ) //Nombre de liens max dans le message.
				{	
					header('location:' . HOST . SCRIPT . transid('?error=l_flood', '', '&') . '#errorh');
					exit;
				}
			
				$sql->query_inject("UPDATE ".PREFIX."guestbook SET contents = '" . $guestbook_contents . "', login = '" . $guestbook_pseudo . "' WHERE id = '" . $id_get . "'", __LINE__, __FILE__);
			
				header('location:' . HOST . SCRIPT. SID2 . '#m' . $id_get);
				exit;
			}
			else
			{
				$errorh->error_handler('e_incomplete', E_USER_REDIRECT);
				exit;
			}
		}
		else
		{
			header('location:' . HOST . SCRIPT . SID2);
			exit;
		}
	}
	else
	{
		header('location:' . HOST . SCRIPT . SID2);
		exit;
	}
}
else //Affichage.
{
	$template->set_filenames(array(
		'guestbook' => '../templates/' . $CONFIG['theme'] . '/guestbook/guestbook.tpl'
	));
		
	//Pseudo du membre connect.
	if( $session->data['user_id'] !== -1 )
		$template->assign_block_vars('hidden_guestbook', array(
			'PSEUDO' => $session->data['login']
		));
	else
		$template->assign_block_vars('visible_guestbook', array(
			'PSEUDO' => $LANG['guest']
		));
	
	//Gestion erreur.
	$get_error = !empty($_GET['error']) ? securit($_GET['error']) : '';
	switch($get_error)
	{
		case 'auth':
		$errstr = $LANG['e_unauthorized'];
		break;
		case 'flood':
		$errstr = $LANG['e_flood'];
		break;
		case 'l_flood':
		$errstr = sprintf($LANG['e_l_flood'], $CONFIG_GUESTBOOK['guestbook_max_link']);
		break;
		case 'incomplete':
		$errstr = $LANG['e_incomplete'];
		break;
		default:
		$errstr = '';
	}
	if( !empty($errstr) )
		$errorh->error_handler($errstr, E_USER_NOTICE);
	
	$nbr_guestbook = $sql->count_table('guestbook', __LINE__, __FILE__);
	//On cre une pagination si le nombre de msg est trop important.
	include_once('../includes/pagination.class.php'); 
	$pagination = new Pagination();
		
	$forbidden_tags = implode(', ', $CONFIG_GUESTBOOK['guestbook_forbidden_tags']);
	$template->assign_vars(array(
		'UPDATE' => transid(''),
		'PAGINATION' => $pagination->show_pagin('guestbook' . transid('.php?p=%d'), $nbr_guestbook, 'p', 10, 3),
		'FORBIDDEN_TAGS' => !empty($forbidden_tags) ? $forbidden_tags : '',
		'DISPLAY_FORBIDDEN_TAGS' => !empty($forbidden_tags) ? '[' . str_replace(', ', '], [', $forbidden_tags) . ']' : '',
		'L_FORBIDDEN_TAGS' => !empty($forbidden_tags) ? $LANG['forbidden_tags'] : '',
		'L_ALERT_TEXT' => $LANG['require_text'],
		'L_DELETE_MSG' => $LANG['alert_delete_msg'],
		'L_ADD_MSG' => $LANG['add_msg'],
		'L_REQUIRE' => $LANG['require'],
		'L_MESSAGE' => $LANG['message'],
		'L_PSEUDO' => $LANG['pseudo'],
		'L_SUBMIT' => $LANG['submit'],
		'L_PREVIEW' => $LANG['preview'], 
		'L_RESET' => $LANG['reset'],
		'L_ON' => $LANG['on']
	));
		
	//Cration du tableau des rangs.
	$array_ranks = array(-1 => $LANG['guest'], 0 => $LANG['member'], 1 => $LANG['modo'], 2 => $LANG['admin']);
	
	//Gestion des rangs.	
	$cache->load_file('ranks');
	$result = $sql->query_while("SELECT g.id, g.login, g.user_id, g.timestamp, m.login as mlogin, m.level, m.user_mail, m.user_show_mail, m.timestamp AS registered, m.user_avatar, m.user_msg, m.user_local, m.user_web, m.user_sex, m.user_msn, m.user_yahoo, m.user_sign, m.user_warning, m.user_ban, m.user_groups, s.user_id AS connect, g.contents
	FROM ".PREFIX."guestbook as g
	LEFT JOIN ".PREFIX."member AS m ON m.user_id = g.user_id
	LEFT JOIN ".PREFIX."sessions AS s ON s.user_id = g.user_id AND s.session_time > '" . (time() - $CONFIG['site_session_invit']) . "'
	GROUP BY g.id
	ORDER BY g.timestamp DESC 
	" . $sql->sql_limit($pagination->first_msg(10, 'p'), 10), __LINE__, __FILE__);	
	while ($row = $sql->sql_fetch_assoc($result))
	{
		$row['user_id'] = (int)$row['user_id'];
			$edit = '';
			$del = '';
			
			$is_guest = ($row['user_id'] === -1);
			$is_modo = $session->check_auth($session->data, 1);
			$warning = '';
			$readonly = '';
			if( $is_modo && !$is_guest ) //Modration.
			{
				$warning = '&nbsp;<a href="../member/moderation_panel' . transid('.php?action=warning&amp;id=' . $row['user_id']) . '" title="' . $LANG['warning_management'] . '"><img src="../templates/' . $CONFIG['theme'] . '/images/admin/important.png" alt="' . $LANG['warning_management'] .  '" class="valign_middle" /></a>'; 
				$readonly = '<a href="../member/moderation_panel' . transid('.php?action=punish&amp;id=' . $row['user_id']) . '" title="' . $LANG['punishment_management'] . '"><img src="../templates/' . $CONFIG['theme'] . '/images/readonly.png" alt="' . $LANG['punishment_management'] .  '" class="valign_middle" /></a>'; 
			}
			
			//Edition/suppression.
			if( $is_modo || ($row['user_id'] === $session->data['user_id'] && $session->data['user_id'] !== -1) )
			{
				$edit = '&nbsp;&nbsp;<a href="../guestbook/guestbook' . transid('.php?edit=1&id=' . $row['id']) . '"><img src="../templates/' . $CONFIG['theme'] . '/images/' . $CONFIG['lang'] . '/edit.png" alt="' . $LANG['edit'] . '" title="' . $LANG['edit'] . '" class="valign_middle" /></a>';
				$del = '&nbsp;&nbsp;<a href="../guestbook/guestbook' . transid('.php?del=1&id=' . $row['id']) . '" onClick="javascript:return Confirm();"><img src="../templates/' . $CONFIG['theme'] . '/images/' . $CONFIG['lang'] . '/delete.png" alt="' . $LANG['delete'] . '" title="' . $LANG['delete'] . '" class="valign_middle" /></a>';
			}
			
			//Pseudo.
			if( !$is_guest ) 
				$guestbook_pseudo = '<a class="msg_link_pseudo" href="../member/member' . transid('.php?id=' . $row['user_id'], '-' . $row['user_id'] . '.php') . '" title="' . $row['mlogin'] . '"><span style="font-weight: bold;">' . wordwrap_html($row['mlogin'], 13) . '</span></a>';
			else
				$guestbook_pseudo = '<span style="font-style:italic;">' . (!empty($row['login']) ? wordwrap_html($row['login'], 13) : $LANG['guest']) . '</span>';
			
			//Rang de l'utilisateur.
			$user_rank = ($row['level'] === '0') ? $LANG['member'] : $LANG['guest'];
			$user_group = $user_rank;
			if( $row['level'] === '2' ) //Rang spcial (admins).  
			{
				$user_rank = $_array_rank[-2][0];
				$user_group = $user_rank;
				$user_rank_icon = $_array_rank[-2][1];
			}
			elseif( $row['level'] === '1' ) //Rang spcial (modos).  
			{
				$user_rank = $_array_rank[-1][0];
				$user_group = $user_rank;
				$user_rank_icon = $_array_rank[-1][1];
			}
			else
			{
				foreach($_array_rank as $msg => $ranks_info)
				{
					if( $msg >= 0 && $msg <= $row['user_msg'] )
					{ 
						$user_rank = $ranks_info[0];
						$user_rank_icon = $ranks_info[1];
						break;
					}
				}
			}
			
			//Image associe au rang.
			$user_assoc_img = isset($user_rank_icon) ? '<img src="../templates/' . $CONFIG['theme'] . '/images/ranks/' . $user_rank_icon . '" alt="" />' : '';
						
			//Affichage des groupes du membre.		
			if( !empty($row['user_groups']) && $_array_groups_auth ) 
			{	
				$user_groups = '';
				$array_user_groups = explode('|', $row['user_groups']);
				foreach($_array_groups_auth as $idgroup => $array_group_info)
				{
					if( is_numeric(array_search($idgroup, $array_user_groups)) )
						$user_groups .= !empty($array_group_info[1]) ? '<img src="../images/group/' . $array_group_info[1] . '" alt="' . $array_group_info[0] . '" title="' . $array_group_info[0] . '"/><br />' : $LANG['group'] . ': ' . $array_group_info[0];
				}
			}
			else
				$user_groups = $LANG['group'] . ': ' . $user_group;
			
			//Membre en ligne?
			$user_online = !empty($row['connect']) ? 'online' : 'offline';
			
			//Avatar			
			if( empty($row['user_avatar']) ) 
				$user_avatar = ($CONFIG_MEMBER['activ_avatar'] == '1' && !empty($CONFIG_MEMBER['avatar_url'])) ? '<img src="../templates/' . $CONFIG['theme'] . '/images/' .  $CONFIG_MEMBER['avatar_url'] . '" alt="" />' : '';
			else
				$user_avatar = '<img src="' . $row['user_avatar'] . '" alt=""	/>';
			
			//Affichage du sexe et du statut (connect/dconnect).	
			$user_sex = '';
			if( $row['user_sex'] == 1 )	
				$user_sex = $LANG['sex'] . ': <img src="../templates/' . $CONFIG['theme'] . '/images/man.png" alt="" /><br />';	
			elseif( $row['user_sex'] == 2 ) 
				$user_sex = $LANG['sex'] . ': <img src="../templates/' . $CONFIG['theme'] . '/images/woman.png" alt="" /><br />';
					
			//Nombre de message.
			$user_msg = ($row['user_msg'] > 1) ? $LANG['message_s'] . ': ' . $row['user_msg'] : $LANG['message'] . ': ' . $row['user_msg'];
			
			//Localisation.
			if( !empty($row['user_local']) ) 
			{
				$user_local = $LANG['place'] . ': ' . $row['user_local'];
				$user_local = $user_local > 15 ? htmlentities(substr(html_entity_decode($user_local), 0, 15)) . '...<br />' : $user_local . '<br />';			
			}
			else $user_local = '';
			
			$template->assign_block_vars('guestbook',array(
				'ID' => $row['id'],
				'CONTENTS' => ucfirst(second_parse($row['contents'])),
				'DATE' => $LANG['on'] . ': ' . date($LANG['date_format'] . ' ' . $LANG['at'] . ' H\hi', $row['timestamp']),
				'USER_ONLINE' => '<img src="../templates/' . $CONFIG['theme'] . '/images/' . $user_online . '.png" alt="" class="valign_middle" />',
				'USER_PSEUDO' => $guestbook_pseudo,			
				'USER_RANK' => (($row['user_warning'] < '100' || (time() - $row['user_ban']) < 0) ? $user_rank : $LANG['banned']),
				'USER_IMG_ASSOC' => $user_assoc_img,
				'USER_AVATAR' => $user_avatar,			
				'USER_GROUP' => $user_groups,
				'USER_DATE' => !$is_guest ? $LANG['registered_on'] . ': ' . date($LANG['date_format'], $row['registered']) : '',
				'USER_SEX' => $user_sex,
				'USER_MSG' => !$is_guest ? $user_msg : '',
				'USER_LOCAL' => $user_local,
				'USER_MAIL' => (!empty($row['user_mail']) && ($row['user_show_mail'] == '1')) ? '<a href="mailto:' . $row['user_mail'] . '"><img src="../templates/' . $CONFIG['theme'] . '/images/' . $CONFIG['lang'] . '/email.png" alt="' . $row['user_mail']  . '" title="' . $row['user_mail']  . '" /></a>' : '',			
				'USER_MSN' => !empty($row['user_msn']) ? '<a href="mailto:' . $row['user_msn'] . '"><img src="../templates/' . $CONFIG['theme'] . '/images/' . $CONFIG['lang'] . '/msn.png" alt="' . $row['user_msn']  . '" title="' . $row['user_msn']  . '" /></a>' : '',
				'USER_YAHOO' => !empty($row['user_yahoo']) ? '<a href="mailto:' . $row['user_yahoo'] . '"><img src="../templates/' . $CONFIG['theme'] . '/images/' . $CONFIG['lang'] . '/yahoo.png" alt="' . $row['user_yahoo']  . '" title="' . $row['user_yahoo']  . '" /></a>' : '',
				'USER_SIGN' => !empty($row['user_sign']) ? '____________________<br />' . $row['user_sign'] : '',
				'USER_WEB' => !empty($row['user_web']) ? '<a href="' . $row['user_web'] . '"><img src="../templates/' . $CONFIG['theme'] . '/images/' . $CONFIG['lang'] . '/user_web.png" alt="' . $row['user_web']  . '" title="' . $row['user_yahoo']  . '" /></a>' : '',
				'WARNING' => (!empty($row['user_warning']) ? $row['user_warning'] : '0') . '%' . $warning,
				'PUNISHMENT' => $readonly,			
				'DEL' => $del,
				'EDIT' => $edit,
				'U_ANCHOR' => 'guestbook.php' . SID . '#m' . $row['id']
			));
	}
	$sql->close($result);
		
	$_field = 'guestbook_contents';
	include_once('../includes/bbcode.php');
	$template->assign_var_from_handle('BBCODE', 'bbcode');
		
	$template->pparse('guestbook'); 
}

include_once('../includes/footer.php'); 

?>