<?php
/*##################################################
 *                                bench.class.php
 *                            -------------------
 *   begin                : March 14, 2006
 *   copyright          : (C) 2005 Viarre Rgis
 *   email                : crowkait@phpboost.com
 *
 *   Function 2.0.0 
 *
###################################################
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
###################################################*/

//Classe grant le multi-bench, permet de calculer trs prcisemment le temps d'execution d'un ou plusieurs morceau de code.

class Bench
{
	var $bench = array(); //Array contenant le total du temps d'execution des diffrents bench en cours.
	var $bench_part = array(); //Array contenant les diffrentes parties du bench en cours.
	var $number_format = 3; //Nombre de dcimales aprs la virgule, affiches dans le rsultat.
	
	//Rcupre l'heure en microsecondes 
	function get_microtime() 
	{
		list($usec, $sec) = explode(" ", microtime());
		return ((float)$usec + (float)$sec);
	}
	
	//Lancement du bench.
	function start_bench($name)
	{
		$this->bench_part[$name] = $this->get_microtime();
	}

	//Calcul et retourne le temps coul.
	function end_bench($name)
	{
		$this->bench[$name] = isset($this->bench[$name]) ? $this->bench[$name] : 0;
		$this->bench[$name] += ($this->get_microtime() - $this->bench_part[$name]);
	}
	
	//Calcul et retourne le temps coul.
	function show_bench($name)
	{
		return arrondi($this->bench[$name], $this->number_format);
	}
}
?>