<?php
/*##################################################
 *                               calendar.php
 *                            -------------------
 *   begin                : January, 25 2007
 *   copyright          : (C) 2007 Viarre Rgis
 *   email                : crowkait@phpboost.com
 *
 *
###################################################
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
###################################################*/

include_once('../includes/begin.php');
define('TITLE', '');
include_once('../includes/header_no_display.php');

//Vide par dfaut => Type date.
$calendar_type = !empty($_GET['date']) ? 'timestamp' : 'date';
$field = !empty($_GET['field']) ? trim($_GET['field']) : 'calendar';
$input_field = !empty($_GET['input_field']) ? trim($_GET['input_field']) : '';
$lyear = !empty($_GET['lyear']) ? '&amp;lyear=1' : '';

$template->set_filenames(array(
	'calendar' => '../templates/' . $CONFIG['theme'] . '/calendar.tpl'
));

//Type date.
if( $calendar_type == 'date' )
{
	$year = date('Y');
	$month = date('n');
	$day = date('j');

	$year = !empty($_GET['y']) ? numeric($_GET['y']) : $year;
	$month = !empty($_GET['m']) ? numeric($_GET['m']) : $month;
	$day = !empty($_GET['d']) ? numeric($_GET['d']) : $day;
	if( !checkdate($month, $day, $year) )
		list($year, $month, $day) = array(date('Y'), date('n'), date('j'));		
	$bissextile = (($year % 4) == 0) ? 29 : 28;

	$array_month = array(31, $bissextile, 31, 30, 31, 30 , 31, 31, 30, 31, 30, 31);
	$array_l_month = array($LANG['january'], $LANG['february'], $LANG['march'], $LANG['april'], $LANG['may'], $LANG['june'], 
	$LANG['july'], $LANG['august'], $LANG['september'], $LANG['october'], $LANG['november'], $LANG['december']);
	$month_day = $array_month[$month - 1];
		
	$template->assign_vars(array(
		'FIELD' => $field,
		'INPUT_FIELD' => $input_field,
		'LYEAR' => $lyear,
		'MONTH' => $month,
		'YEAR' => $year,
		'U_PREVIOUS' => ($month == 1) ? 'input_field=' . $input_field . '&amp;field=' . $field . $lyear . '&amp;d=' . $day . '&amp;m=12&amp;y=' . ($year - 1) :  'input_field=' . $input_field . '&amp;input_field=' . $input_field . '&amp;field=' . $field . $lyear . '&amp;d=1&amp;m=' . ($month - 1) . '&amp;y=' . $year,
		'U_NEXT' => ($month == 12) ? 'input_field=' . $input_field . '&amp;field=' . $field . $lyear . '&amp;d=' . $day . '&amp;m=1&amp;y=' . ($year + 1) :  'input_field=' . $input_field . '&amp;field=' . $field . $lyear . '&amp;d=1&amp;m=' . ($month + 1) . '&amp;y=' . $year
	));	

	//Gnration des select.
	for($i = 1; $i <= 12; $i++)
	{
		$selected = ($month == $i) ? 'selected="selected"' : '';
		$template->assign_block_vars('month', array(
			'MONTH' => '<option value="' . $i . '" ' . $selected . '>' . htmlentities($array_l_month[$i - 1]) . '</option>'
		));
	}			
	for($i = 1970; $i <= 2037; $i++)
	{
		$selected = ($year == $i) ? 'selected="selected"' : '';
		$template->assign_block_vars('year', array(
			'YEAR' => '<option value="' . $i . '" ' . $selected . '>' . $i . '</option>'
		));
	}
		
	//Gnration des jours du calendrier.
	$array_l_days =  array($LANG['monday'], $LANG['tuesday'], $LANG['wenesday'], $LANG['thursday'], $LANG['friday'], $LANG['saturday'], 
	$LANG['sunday']);
	foreach($array_l_days as $l_day)
	{
		$template->assign_block_vars('day', array(
			'L_DAY' => '<td style="width:25px;border-top:1px solid black;border-bottom:1px solid black"><span class="text_small">' . $l_day . '</span></td>'
		));
	}	

	//Premier jour du mois.
	$first_day = @date('w', @mktime(1, 0, 0, $month, 1, $year)); 
	if( $first_day == 0 )
		$first_day = 7;
		
	//Prise en compte et converstion des formats de dates.
	$format = '';
	$array_date = explode('/', $LANG['date_format']);
	for($i = 0; $i < 3; $i++)
	{
		switch($array_date[$i])
		{
			case 'd':
			$format .= "%1\$s";
			break;
			case 'm':
			$format .= "%2\$s";
			break;
			case 'y':
			$format .= "%3\$s";
			break;		
		}
		$format .= ($i != 2) ? '/' : '';
	}

	//Gnration du calendrier. 
	$year = !empty($lyear) ? $year : substr($year, 2, 2);
	$month = ($month < 10 && substr($month, 0, 1) != 0) ? '0' . $month : $month;
	$j = 1;
	$last_day = ($month_day + $first_day);
	for($i = 1; $i <= 42; $i++)
	{
		if( $i >= $first_day && $i < $last_day )
		{
			$class = ($day == $j) ? ' style="padding:0px;" class="row2"' : ' style="padding:0px;" class="row3"';
			$style = ($day == $j) ? 'border: 1px inset black;' : 'border: 1px outset black;';
			$date = sprintf($format, (($j < 10 && substr($j, 0, 1) != 0) ? '0' . $j : $j), $month, $year);
			
			$contents = '<td' . $class . '><div style="' . $style . 'padding:2px;"><a href="javascript:insert_date(\'' . $input_field . '\', \'' . $date . '\');">' . $j . '</a></div></td>';
			$j++;
		}
		else
			$contents = '<td style="padding:0px;height:21px;" class="row3">&nbsp;</td>';

		$template->assign_block_vars('calendar', array(
			'DAY' => $contents,
			'TR' => (($i % 7) == 0 && $i != 42) ? '</tr><tr style="text-align:center;">' : ''
		));
	}
}
else
{
	//Non support
}

$template->pparse('calendar');	
	
include_once('../includes/footer_no_display.php');
?>