<?php
/*##################################################
 *                               history.php
 *                            -------------------
 *   begin                : October 09, 2006
 *   copyright          : (C) 2006 Sautel Benoit
 *   email                : ben.popeye@phpboost.com
 *
 *
###################################################
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
###################################################*/

include_once('../includes/begin.php'); 
include_once('../wiki/lang/' . $CONFIG['lang'] . '/wiki_' . $CONFIG['lang'] . '.php');

$id_article = !empty($_GET['id']) ? numeric($_GET['id']) : 0;
$field = !empty($_GET['field']) ? securit($_GET['field']) : '';
$order = !empty($_GET['order']) ? securit($_GET['order']) : '';

define('TITLE' , $LANG['wiki_history']);

if( !empty($id_article) )
{
	$article_infos = $sql->query_array('wiki_articles', 'title', 'auth', 'encoded_title', 'id_cat', 'WHERE id = ' . $id_article, __LINE__, __FILE__);
}

$speed_bar_key = !empty($id_article) ? 'wiki_history_article' : 'wiki_history';
require_once('../wiki/wiki_speed_bar.php');

include_once('../includes/header.php'); 

if( !empty($id_article) )
{
	$template->set_filenames(array('wiki_history' => '../templates/' . $CONFIG['theme'] . '/wiki/history.tpl'));

	$template->assign_block_vars('article', array(
		'L_TITLE' => $LANG['wiki_history'] . ': <a href="' . $article_infos['encoded_title'] . '">' . $article_infos['title'] . '</a>',
	));
	
	$general_auth = empty($article_infos['auth']) ? true : false;
	$article_auth = !empty($article_infos['auth']) ? unserialize($article_infos['auth']) : array();
	$restore_auth = (!$general_auth || $groups->check_auth($_WIKI_CONFIG['auth'], WIKI_RESTORE_ARCHIVE)) && ($general_auth || $groups->check_auth($article_auth , WIKI_RESTORE_ARCHIVE)) ? true : false;
	$delete_auth = (!$general_auth || $groups->check_auth($_WIKI_CONFIG['auth'], WIKI_DELETE_ARCHIVE)) && ($general_auth || $groups->check_auth($article_auth , WIKI_DELETE_ARCHIVE)) ? true : false;
	
	//on va chercher le contenu de la page
	$result = $sql->query_while("SELECT a.title, a.encoded_title, c.timestamp, c.id_contents, c.user_id, c.user_ip, m.login, c.id_article, c.activ
		FROM ".PREFIX."wiki_contents AS c
		LEFT JOIN ".PREFIX."wiki_articles AS a ON a.id = c.id_article
		LEFT JOIN ".PREFIX."member AS m ON m.user_id = c.user_id
		WHERE c.id_article = '" . $id_article . "'
		ORDER BY c.timestamp DESC", __LINE__, __FILE__);
	
	while( $row = $sql->sql_fetch_assoc($result) )
	{
		//Restauration
		$actions = ($row['activ'] != 1 && $restore_auth) ? '<a href="' . transid('action.php?restore=' . $row['id_contents']) . '" title="' . $LANG['wiki_restore_version'] . '"><img src="templates/images/restore.png" alt="' . $LANG['wiki_restore_version'] . '" /></a> &nbsp; ' : '';
		
		//Suppression
		$actions .= ($row['activ'] != 1 && $delete_auth) ? '<a href="' . transid('action.php?del_contents=' . $row['id_contents']) . '" title="' . $LANG['delete'] . '" onclick="javascript: return confirm(\'' . str_replace('\'', '\\\'', $LANG['wiki_confirm_delete_archive']) . '\');"><img src="' . $template->module_data_path('wiki') . '/images/delete.png" alt="' . $LANG['delete'] . '" /></a>' : '';
		
		
		$template->assign_block_vars('article.list', array(
			'TITLE' => $LANG['wiki_consult_article'],
			'AUTHOR' => !empty($row['login']) ? '<a href="../member/member' . transid('.php?id=' . $row['user_id'], '-' . $row['user_id'] . '.php') . '">' . $row['login'] . '</a>' : $row['user_ip'],
			'DATE' => date($LANG['date_format'] . ' ' . $LANG['at'] . ' H\hi', $row['timestamp']),
			'U_ARTICLE' => $row['activ'] == 1 ? transid('wiki.php?title=' . $row['encoded_title'], $row['encoded_title']) : transid('wiki.php?id_contents=' . $row['id_contents']),
			'CURRENT_RELEASE' => $row['activ'] == 1 ? '(' . $LANG['wiki_current_version'] . ')' : '',
			'ACTIONS' => !empty($actions) ? $actions : $LANG['wiki_no_possible_action']
		));
	}
	$sql->close($result);
	
	$template->assign_vars(array(
		'L_VERSIONS' => $LANG['wiki_version_list'],
		'L_DATE' => $LANG['date'],
		'L_AUTHOR' => $LANG['wiki_author'],
		'L_ACTIONS' => $LANG['wiki_possible_actions'],
		));
	
	$template->pparse('wiki_history');	
}
else //On affiche la liste des modifications 
{
	$_WIKI_NBR_ARTICLES_A_PAGE_IN_HISTORY = 25;
	
	//Champs sur lesquels on ordonne
	$field = ($field == 'title') ? 'title' : 'timestamp';
	$order = $order == 'asc' ? 'asc' : 'desc';
	
	//On compte le nombre d'articles
	$nbr_articles = $sql->query("SELECT COUNT(*) FROM ".PREFIX."wiki_articles WHERE redirect = '0'", __LINE__, __FILE__);
	
	//On instancie la classe de pagination
	include_once('../includes/pagination.class.php');
	$pagination = new Pagination();
	$show_pagin = $pagination->show_pagin(transid('history.php?field=' . $field . '&amp;order=' . $order . '&amp;p=%d'), $nbr_articles, 'p', $_WIKI_NBR_ARTICLES_A_PAGE_IN_HISTORY, 3); 
	
	$template->set_filenames(array('wiki_history' => '../templates/' . $CONFIG['theme'] . '/wiki/history.tpl'));

	$template->assign_block_vars('index', array(
		'L_HISTORY' => $LANG['wiki_history'],
		'L_TITLE' => $LANG['wiki_article_title'],
		'L_AUTHOR' => $LANG['wiki_author'],
		'L_DATE' => $LANG['date'],
		'ARROW_TOP_TITLE' => ($field == 'title' && $order == 'asc') ? '' : '<a href="' . transid('history.php?p=' . $pagination->page . '&amp;field=title&amp;order=asc') . '"><img src="../templates/' . $CONFIG['theme'] . '/images/top.png" alt="asc" /></a>',
		'ARROW_BOTTOM_TITLE' => ($field == 'title' && $order == 'desc') ? '' : '<a href="' . transid('history.php?p=' . $pagination->page . '&amp;field=title&amp;order=desc') . '"><img src="../templates/' . $CONFIG['theme'] . '/images/bottom.png" alt="desc" /></a>',
		'ARROW_TOP_DATE' => ($field == 'timestamp' && $order == 'asc') ? '' : '<a href="' . transid('history.php?p=' . $pagination->page . '&amp;field=timestamp&amp;order=asc') . '"><img src="../templates/' . $CONFIG['theme'] . '/images/top.png" alt="asc" /></a>',
		'ARROW_BOTTOM_DATE' => ($field == 'timestamp' && $order == 'desc') ? '' : '<a href="' . transid('history.php?p=' . $pagination->page . '&amp;field=timestamp&amp;order=desc') . '"><img src="../templates/' . $CONFIG['theme'] . '/images/bottom.png" alt="desc" /></a>',
		'PAGINATION' => ($nbr_articles > $_WIKI_NBR_ARTICLES_A_PAGE_IN_HISTORY  ?  $show_pagin : '') //Affichage de la pagination si il le faut
	));	

	$result = $sql->query_while("SELECT a.title, a.encoded_title, c.timestamp, c.id_contents AS id, c.user_id, c.user_ip, m.login, c.id_article, c.activ,  a.id_contents
		FROM ".PREFIX."wiki_articles AS a
		LEFT JOIN ".PREFIX."wiki_contents AS c ON c.id_contents = a.id_contents
		LEFT JOIN ".PREFIX."member AS m ON m.user_id = c.user_id
		WHERE a.redirect = 0
		ORDER BY " . ($field == 'title' ? 'a' : 'c') . "." . $field . " " . $order . "
		" . $sql->sql_limit($pagination->first_msg($_WIKI_NBR_ARTICLES_A_PAGE_IN_HISTORY, 'p'),$_WIKI_NBR_ARTICLES_A_PAGE_IN_HISTORY), __LINE__, __FILE__);
	while( $row = mysql_fetch_assoc($result) )
	{
		$template->assign_block_vars('index.list', array(
			'TITLE' => $row['title'],
			'AUTHOR' => !empty($row['login']) ? '<a href="../member/member' . transid('.php?id=' . $row['user_id'], '-' . $row['user_id'] . '.php') . '">' . $row['login'] . '</a>' : $row['user_ip'],
			'DATE' => date($LANG['date_format'] . ' ' . $LANG['at'] . ' H\hi', $row['timestamp']),
			'U_ARTICLE' => transid('wiki.php?title=' . $row['encoded_title'], $row['encoded_title'])
		));
	}
	
	$template->pparse('wiki_history');
}

include_once('../includes/footer.php'); 
?>